import { HttpErrorResponse } from '@angular/common/http';

export type ErrorSnackbarData = { title: string, error: HttpErrorResponse | object };

// redefinition (alias) for autogenerated backend type
export type HttpError = HttpErrorResponse;
export const VALIDATION_ERROR_STATUS_CODE = 401;
export const FORBIDDEN_ERROR_STATUS_CODE = 403;
export const EXAMINATION_CLOSED_ERROR_STATUS_CODE = 423;

export type SelectionError =
  | 'NO_SCOPE_SELECTION'
  | 'NO_SLIDE_SELECTION';

const LOAD_ERROR = `Error fetching`;
const POST_ERROR = 'Error posting';
const UPDATE_ERROR = 'Error updating';
const DELETE_ERROR = 'Error deleting';
export const EXTENDED_SCOPE_LOAD_ERROR = `${LOAD_ERROR} Extended Scope`;
export const EAD_COMPATIBILITY_ERROR = 'Generic App Ui is not compatible with ead input';
export const ANNOTATIONS_LOAD_ERROR = `${LOAD_ERROR} annotations`;
export const CREATE_ANNOTATION_ERROR = `${POST_ERROR} annotation`;
export const DELETE_ANNOTATION_ERROR = `${DELETE_ERROR} annotation`;
export const JOBS_LOAD_ERROR = `${LOAD_ERROR} jobs`;
export const CREATE_JOB_ERROR = `${POST_ERROR} job`;
export const DELETE_JOB_ERROR = `${DELETE_ERROR} job`;
export const DELETE_JOB_INPUT_OUTPUT_ERROR = `${DELETE_ERROR} job input`;
export const UPDATE_JOB_ERROR = `${UPDATE_ERROR} job`;

export interface ErrorMap {
  [key: string]: string;
}
